<!-- 试卷管理 -->
<template>
  <div class="app-container testPaperManagement">
    <div class="page-container testPaperManagementPage" v-if="pageType === 1">
      <div class="page-form-title-box">
        <el-form :model="queryParams" class="form-box" ref="queryForm"
                 :inline="true" style="width:100%;">
          <el-form-item label="" prop="shareStatus">
            <el-select v-model="queryParams.shareStatus" placeholder="是否共享" style="width: 120px">
              <el-option label="共享" value="1"/>
              <el-option label="不共享" value="0"/>
            </el-select>
          </el-form-item>
          <el-form-item label="" prop="deptId">
            <el-cascader
              style="width: 180px"
              v-model="queryParams.deptId"
              :options="optionListB"
              :props="{
                    emitPath:false,
                    checkStrictly: true,
                    value: 'deptId',
                    label: 'deptName',
                    children: 'child',
                  }"
              :show-all-levels="false"
              filterable
              placeholder="来源"
            ></el-cascader>
          </el-form-item>
          <el-form-item label="" prop="knowledgePointId">
            <el-cascader
              style="width: 180px"
              v-model="queryParams.knowledgePointId"
              :options="optionListC"
              :props="{
                emitPath:false,
                checkStrictly: true,
                value: 'id',
                label: 'knowledgePointName',
                children: 'children',
              }"
              :show-all-levels="false"
              filterable
              placeholder="知识点"
            ></el-cascader>
          </el-form-item>
          <el-form-item label="" prop="disciplineTypeId">
            <el-select v-model="queryParams.disciplineTypeId" placeholder="试卷分类" style="width: 200px">
              <el-option
                v-for="dict in disciplineOptionList"
                :key="dict.id"
                :label="dict.disciplineName"
                :value="dict.id"
              />
            </el-select>
          </el-form-item>
          <el-form-item label="" prop="assemblyMode">
            <el-select v-model="queryParams.assemblyMode" placeholder="组卷方式" style="width: 140px">
              <el-option label="固定组卷" value="1"/>
              <el-option label="随机组卷" value="2"/>
            </el-select>
          </el-form-item>
          <el-form-item label="" prop="searchValue">
            <el-input
              maxLength="30"
              v-model="queryParams.searchValue"
              placeholder="搜索名称"
              style="width: 140px"
            />
          </el-form-item>
          <p class="page-inquire-common-style-button" @click="handleQuery">查询</p>
          <p class="page-reset-common-style-button" @click="resetQuery">重置</p>
          <p class="page-submit-common-style-button"
             style="float: right;"
             v-hasPermiRouter="['exam:elPaper:add']"
             @click="tableButton(1)"
          >新建试卷</p>
        </el-form>
      </div>
      <div class="page-content-box">
        <el-table class="table-box"  border :data="dataList">
          <el-table-column label="试卷名称" prop="paperName"  show-overflow-tooltip>
            <template slot-scope="scope">
              <span style="color:#0183fa;cursor: pointer" @click="tableButton(2,scope.row)">{{scope.row.paperName}}</span>
            </template>
          </el-table-column>
          <el-table-column label="组卷方式" prop="assemblyMode" width="120" show-overflow-tooltip>
            <template slot-scope="scope">
              <span>{{scope.row.assemblyMode==1?'固定组卷':'随机组卷'}}</span>
            </template>
          </el-table-column>
          <el-table-column label="知识点" prop="knowledgePointNames" width="160" show-overflow-tooltip/>
          <el-table-column label="试卷分类" prop="disciplineTypeName" width="120" show-overflow-tooltip/>
          <el-table-column label="是否共享" prop="shareStatus" width="120" show-overflow-tooltip>
            <template slot-scope="scope">
              <span style="padding:2px 10px;border:1px solid rgb(1, 131, 251);border-radius:4px;color: rgb(1, 131, 251);background-color:rgba(1, 131, 251,0.2)" v-if="scope.row.shareStatus==1">共享</span>
              <span style="padding:2px 10px;border:1px solid rgb(245, 154, 35);border-radius:4px;color: rgb(245, 154, 35);background-color:rgba(245, 154, 35,0.2)" v-if="scope.row.shareStatus==0">不共享</span>
            </template>
          </el-table-column>
          <el-table-column label="来源" prop="deptName" width="160" show-overflow-tooltip/>
          <el-table-column label="总分" prop="totalScore" width="100" show-overflow-tooltip/>
          <el-table-column label="及格分" prop="passScore" width="100" show-overflow-tooltip/>
          <el-table-column label="更新时间" prop="createTime" width="180" show-overflow-tooltip>
            <template slot-scope="scope">
              <span>{{ scope.row.updateTime?parseTime(scope.row.updateTime,"{y}-{m}-{d} {h}:{i}"):parseTime(scope.row.createTime,"{y}-{m}-{d} {h}:{i}") }}</span>
            </template>
          </el-table-column>
          <el-table-column label="操作" width="200" show-overflow-tooltip v-if="tableButtonType">
            <template slot-scope="scope">
              <div class="table-button-box">
                <p class="table-button-null"></p>
                <p class="table-button-p"
                   v-if="scope.row.canEditDelete"
                   v-hasPermiRouter="['exam:elPaper:edit']"
                   @click="tableButton(3,scope.row)"
                >编辑</p>
                <p class="table-button-p"
                   v-hasPermiRouter="['exam:elPaper:copy']"
                   @click="tableButton(4,scope.row)"
                >复制</p>
                <p class="table-button-p"
                   v-if="scope.row.canEditDelete"
                   v-hasPermiRouter="['exam:elPaper:del']"
                   @click="tableButton(5,scope.row)"
                >删除</p>
                <p class="table-button-null"></p>
              </div>
            </template>
          </el-table-column>
        </el-table>
        <pagination :page-sizes="[20, 30, 40, 50]"
                    v-show="total>0"
                    :total="total"
                    :page.sync="queryParams.page"
                    :limit.sync="queryParams.pageSize"
                    @pagination="getList"
        />
      </div>
    </div>
    <add-page :propsData="propsData" v-if="pageType === 2"></add-page>
  </div>
</template>
<script>
  //import { getDicts } from "@/api/commonality/noPermission";
  //import { systemUserSelect } from "@/api/commonality/permission";
  //import { getInfo } from "@/api/basicsModules/index";
  import addPage from "./addPage.vue";
  import {
    examElPaperPage,examElPaperDel,examElPaperCopy,
    examElDisciplineTypeList,systemDeptCurrentDept,examElKnowledgePointTreeList,
  } from "@/api/safetyEducationExaminationNew/index";
  export default {
    name: 'index',
    components: {
     addPage
    },
    data () {
      return {
        tableButtonType:this.hasPermiDom(['exam:elPaper:edit','exam:elPaper:copy','exam:elPaper:del',]),
        //页面状态
        pageType:1,
        //下拉列表数据
        optionListB:[],
        optionListC:[],
        disciplineOptionList:[],
        //查询条件
        queryParams:{
          page:1,
          pageSize:20,
          searchValue:'',
          shareStatus :null,
          deptId :null,
          knowledgePointId :null,
          assemblyMode :null,
          disciplineTypeId :null,
        },
        //列表数据
        dataList:[],
        //数据数量
        total:0,
        //组件传参
        propsData:{},
      }
    },
    created () {

    },
    mounted () {
      this.systemDeptCurrentDept();
      this.examElKnowledgePointTreeList();
      this.examElDisciplineTypeList();
      this.getList();
    },
    methods: {
      //查询按钮
      handleQuery(){
        this.$set(this.queryParams,'page',1);
        this.getList();
      },
      //重置按钮
      resetQuery(){
        this.$set(this,'queryParams',{
          page:1,
          pageSize:20,
          searchValue:'',
          shareStatus :null,
          deptId :null,
          knowledgePointId :null,
          assemblyMode :null,
          disciplineTypeId :null,
        });
        this.getList();
      },
      //获取数据列表
      getList(){

        let obj = JSON.parse(JSON.stringify(this.queryParams))
        examElPaperPage(obj).then(response => {

          this.$set(this,'dataList',response.data.records);
          this.$set(this,'total',response.data.total);
        });
      },
      //操作按钮
      tableButton(type,row){
        let self = this;
        if(type == 1){
          //新增
          this.$set(this,'pageType',2);
          this.$set(this,'propsData',{});
        }else if(type == 2){
          //预览
          this.$set(this,'pageType',2);
          let obj = JSON.parse(JSON.stringify(row))
          obj.showType = true;
          this.$set(this,'propsData',obj);
        }else if(type == 3){
          //编辑
          this.$set(this,'pageType',2);
          let obj = JSON.parse(JSON.stringify(row))
          this.$set(this,'propsData',obj);
        }else if(type == 4){
          //复制
          this.$confirm('是否确认复制?', "提示", {
            confirmButtonText: "确定",
            cancelButtonText: "取消",
            type: "warning"
          }).then(function() {
          }).then(() => {
            examElPaperCopy({id:row.id}).then(response => {
              self.msgSuccess(response.message)
              self.getList();
            });
          }).catch(() => {});
        }else if(type == 5){
          //删除
          this.$confirm('是否确认删除?', "提示", {
            confirmButtonText: "确定",
            cancelButtonText: "取消",
            type: "warning"
          }).then(function() {
          }).then(() => {
            examElPaperDel({id:row.id}).then(response => {
              self.msgSuccess(response.message)
              self.getList();
            });
          }).catch(() => {});
        }else if(type == 6){
          //返回并刷新
          this.$set(this,'pageType',1);
          this.getList();
        }
      },
      //知识点
      examElKnowledgePointTreeList(){
        examElKnowledgePointTreeList({}).then(response => {
          const list = response.data || [];
          this.formatTreeData(list);
          this.$set(this, 'optionListC', list);
        });
      },
      //学院列表
      systemDeptCurrentDept(){
        systemDeptCurrentDept({}).then(response => {
          const list = response.data || [];
          this.formatTreeData(list);
          this.$set(this,'optionListB',response.data);
        });
      },
      //查询全部专业类别
      examElDisciplineTypeList(){
        examElDisciplineTypeList({}).then(response => {
          this.$set(this,'disciplineOptionList',response.data);
        });
      },
    },
  }
</script>
<style scoped lang="scss">
  .testPaperManagement{
    .testPaperManagementPage{

    }
  }
</style>
